// Copyright 1997-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
// $Header: /Network/Source/CVS/OmniGroup/Frameworks/OmniFoundation/DataStructures.subproj/OFQueue.h,v 1.6 2000/01/19 23:35:16 kc Exp $

#import <Foundation/NSObject.h>
#import <OmniBase/SystemType.h>

// Use pthreads on MacOS X DP2 and greater.
#if defined(RHAPSODY) && (OBOperatingSystemMajorVersion > 5)
#define USE_PTHREADS
#include <pthread.h>
#else
#include <mach/cthreads.h>
#endif

@interface OFQueue : NSObject
{
    BOOL closed;
    id *objects;
    unsigned int max, count, head, tail;
#ifdef USE_PTHREADS
    pthread_mutex_t mutex;
    pthread_cond_t condition;
#else
    struct mutex mutex;
    struct condition condition;
#endif
}

- initWithCount:(unsigned int)maxCount;

- (unsigned int)maxCount;
- (unsigned int)count;

- (BOOL)isClosed;
- (void)close;

- (id)dequeueShouldWait:(BOOL)wait;
- (BOOL)enqueue:(id)anObject shouldWait:(BOOL)wait;

@end
