// Copyright 1997-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
// $Header: /Network/Source/CVS/OmniGroup/Frameworks/OmniFoundation/Attic/OFCondition.h,v 1.8 2000/01/19 23:35:06 kc Exp $

#import <OmniFoundation/OFObject.h>

#ifdef FAST_BUGGY_WAY
#import <mach/cthreads.h>
#endif

@class NSConditionLock;

@interface OFCondition : OFObject
{
#ifdef FAST_BUGGY_WAY
    struct condition machCondition;
    struct mutex machMutex;
    unsigned int signalCount;
#else
    NSConditionLock *lock;
    struct {
        unsigned int cleared:1;
    } flags;
#endif
}

- init;

- (void)waitForCondition;

- (void)signalCondition;
- (void)broadcastCondition;

- (void)clearCondition;

@end
